--------------------------------------------------------------------------------
-- scan_ps2.vhd
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity scan_ps2 is
    port(
        ps2d, ps2t  : in    std_logic;
        la  : out   std_logic_vector(1 downto 0);
        led : out   std_logic_vector(7 downto 0)
    );
end entity;

architecture synth of scan_ps2 is
    signal dat: std_logic_vector(10 downto 0);
begin
 process(ps2t) 
 begin
  if rising_edge(ps2t) then
    -- PS/2-Daten in das 10-Bit-Register "dat" schieben
    dat <= ps2d_del & dat(10 downto 1);
   end if;
  end if;
 end process;
 led <= dat(8 downto 1);  -- LED-Schieberegisterausgabe
 la  <= ps2d & ps2t;      -- Ausgabe an den Logikanalysator
end architecture;
