library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity quadenc is
 port(
  um: in  integer range -128 to 127;      -- Drehzahl in Umdrehungen/min
  run: in boolean;                        -- Simulation laeuft
  SA, SB: buffer std_logic:= '0');
 end entity;

architecture a of quadenc is
begin

 process 
  variable tw: delay_length;               -- Wartezeit zur naechsten Sensorflanke
 begin
  if    um>0 then SB <= SA; SA <= not SB;  -- Sensorfolge vorwaerts
  elsif um<0 then SA <= SB; SB <= not SA;  -- Sensorfolge rueckwaerts
  end if;
  if not run then wait;                    -- Simulationsende, Prozess anhalten
  elsif um=0 then wait until um /= 0;      -- wenn Drehzahl null
  end if;                                  -- warten, bis ungleich null
  tw := 60 sec / (abs(um) * 53 * 6 * 2);   -- Wartezeit berechnen
  wait for tw;                             -- Warten
 end process;     
end architecture;
